// ListBoxODData.cpp: implementation of the CListBoxODData class.
// Copyright (c) 2015 by David Wincelberg
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ListBoxODData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// Note:	A memory exception should be handled by the calling function.
CListBoxODData::CListBoxODData (LPCTSTR lpszItem)
{
	m_strItem = lpszItem;
}


CListBoxODData::~CListBoxODData()
{

}

//////////////////////////////////////////////////////////////////////
// Operations
//////////////////////////////////////////////////////////////////////

void CListBoxODData::GetString (CString& rString)
{
	try {
		rString = m_strItem;
	}
	catch (CMemoryException* e) {
		e->Delete();
		rString.Empty();
	}
}	// GetString


// Action:	Copies the data members from another object.
CListBoxODData& CListBoxODData::operator= (const CListBoxODData& other)
{
	if (&other != this) {
		m_nExtent    = other.m_nExtent;
		m_bAdded     = other.m_bAdded;
		m_dwItemData = other.m_dwItemData;
		m_strItem    = other.m_strItem;
	}

	return *this;
}	// operator=
