// ListCtrlData.h: interface for the CListCtrlData class.
// Copyright (c) 2016 by David Wincelberg
//////////////////////////////////////////////////////////////////////

#pragma once

class CListCtrlData
{
// Construction/Destruction
public:
	CListCtrlData (CListCtrl* pListCtrl, LPARAM lParam = 0);
	CListCtrlData (int nCols = 0, LPARAM lParam = 0);
	CListCtrlData (CStringArray& saCols, LPARAM lParam = 0);
	virtual ~CListCtrlData();

// Attributes
private:
	int m_nCols;
	CStringArray m_saCols;
	LPARAM m_lParam;

// Operations
public:
	void SetAt (int nCol, LPCTSTR newElement);
	virtual CString GetAt (int nCol) const;
	void SetLParam (LPARAM lParam) {m_lParam = lParam;};
	LPARAM GetLParam() const {return m_lParam;};
	CListCtrlData& operator= (const CListCtrlData& other);
};
