// SortComboBox.h : header file
// Copyright (c) 2016 by David Wincelberg
/////////////////////////////////////////////////////////////////////////////

#pragma once

class CComboBoxData;
class CComboBoxOrder;
class CStringOrder;

/////////////////////////////////////////////////////////////////////////////
// CSortComboBox window

class CSortComboBox : public CComboBox
{
// Construction/Destruction
public:
	CSortComboBox (CComboBoxOrder* pComboBoxOrder = nullptr, bool bHandleDelete = true);
	CSortComboBox (CStringOrder* pStringOrder, bool bHandleDeleteInner = true,
		bool bHandleDeleteOuter = true);
	virtual ~CSortComboBox();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSortComboBox)
	public:
	virtual void DeleteItem(LPDELETEITEMSTRUCT lpDeleteItemStruct);
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Attributes
private:
	CComboBoxOrder* m_pComboBoxOrder;
	bool m_bHandleDelete;
	bool m_bSorting;
	bool m_bSorted;
	bool m_bAllowOrderMod;

// Operations
public:
	void  SetSortOrder (CComboBoxOrder* pComboBoxOrder, bool bHandleDelete = true);
	void  SetStringOrder (CStringOrder* pStringOrder, bool bHandleDelete = true);
	int   AddString (LPCTSTR lpszItem, CComboBoxData* pComboBoxData = nullptr);
	int   InsertString (int nIndex, LPCTSTR lpszItem, CComboBoxData* pComboBoxData = nullptr);
	int   DeleteString (UINT nIndex);
	void  ResetContent();
	int   SetItemData (int nIndex, DWORD dwItemData);
	DWORD GetItemData (int nIndex) const;
	int   SetItemDataPtr (int nIndex, void* pData);
	void* GetItemDataPtr (int nIndex) const;
	int   SetItemDataObjPtr (int nIndex, CComboBoxData* pComboBoxData);
	CComboBoxData* GetItemDataObjPtr (int nIndex) const;

protected:
	int   SortStrings (CString& strItem1, CComboBoxData* pComboBoxData1, int nCount);

private:
	bool  CheckComboBoxData (CComboBoxData** ppComboBoxData);
	void  DeleteAllItems();

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSortComboBox)
	afx_msg void OnDestroy();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
