// SortListBox.h : header file
// Copyright (c) 2016 by David Wincelberg
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include "ExtentCalcs.h"

class CListBoxData;
class CListBoxOrder;
class CStringOrder;

/////////////////////////////////////////////////////////////////////////////
// CSortListBox window

class CSortListBox : public CListBox, public CExtentCalcs
{
// Construction/Destruction
public:
	CSortListBox (CListBoxOrder* pListBoxOrder = nullptr, bool bHandleDelete = true);
	CSortListBox (CStringOrder* pStringOrder, bool bHandleDeleteInner = true,
		bool bHandleDeleteOuter = true);
	virtual ~CSortListBox();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSortListBox)
	public:
	virtual void DeleteItem(LPDELETEITEMSTRUCT lpDeleteItemStruct);
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Attributes
private:
	CListBoxOrder* m_pListBoxOrder;
	bool m_bHandleDelete;
	bool m_bSorting;
	bool m_bSorted;
	bool m_bAllowOrderMod;

// Operations
public:
	void  SetSortOrder (CListBoxOrder* pListBoxOrder, bool bHandleDelete = true);
	void  SetStringOrder (CStringOrder* pStringOrder, bool bHandleDelete = true);
	int   AddString (LPCTSTR lpszItem, CListBoxData* pListBoxData = nullptr);
	int   InsertString (int nIndex, LPCTSTR lpszItem, CListBoxData* pListBoxData = nullptr);
	int   DeleteString (UINT nIndex);
	void  ResetContent();
	int   SetItemData (int nIndex, DWORD dwItemData);
	DWORD GetItemData (int nIndex) const;
	int   SetItemDataPtr (int nIndex, void* pData);
	void* GetItemDataPtr (int nIndex) const;
	int   SetItemDataObjPtr (int nIndex, CListBoxData* pListBoxData);
	CListBoxData* GetItemDataObjPtr (int nIndex) const;

protected:
	int  SortStrings (CString& strItem1, CListBoxData* pListBoxData1, int nCount);

private:
	bool CheckListBoxData (CListBoxData** ppListBoxData);
	void DeleteAllItems();

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSortListBox)
	afx_msg void OnDestroy();
	//}}AFX_MSG
	afx_msg LRESULT OnSetTabStops (WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
