// SortListBoxOD.h : header file
// Copyright (c) 2016 by David Wincelberg
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include "ExtentCalcs.h"

class CListBoxODData;
class CListBoxODOrder;
class CStringOrder;

/////////////////////////////////////////////////////////////////////////////
// CSortListBoxOD window

class CSortListBoxOD : public CListBox, public CExtentCalcs
{
// Construction/Destruction
public:
	CSortListBoxOD (CListBoxODOrder* pListBoxODOrder = nullptr, bool bHandleDelete = true);
	CSortListBoxOD (CStringOrder* pStringOrder, bool bHandleDeleteInner = true,
		bool bHandleDeleteOuter = true);
	virtual ~CSortListBoxOD();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSortListBoxOD)
	public:
	virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	virtual int CompareItem(LPCOMPAREITEMSTRUCT lpCompareItemStruct);
	virtual void DeleteItem(LPDELETEITEMSTRUCT lpDeleteItemStruct);
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Attributes
private:
	CListBoxODOrder* m_pListBoxODOrder;
	bool m_bHandleDelete;
	bool m_bSorting;
	bool m_bAllowOrderMod;
	int  m_nHeight;

// Operations
public:
	void  SetSortOrder (CListBoxODOrder* pListBoxODOrder, bool bHandleDelete = true);
	void  SetStringOrder (CStringOrder* pStringOrder, bool bHandleDelete = true);
	int   AddString (LPCTSTR lpszItem, CListBoxODData* pListBoxODData = nullptr);
	int   InsertString (int nIndex, LPCTSTR lpszItem,
		  CListBoxODData* pListBoxODData = nullptr);
	int   DeleteString (UINT nIndex);
	int   FindString (int nStartAfter, LPCTSTR lpszItem) const;
	int   FindStringExact (int nStartAfter, LPCTSTR lpszItem) const;
	void  GetText (int nIndex, CString& rString) const;
	int   GetText (int nIndex, LPTSTR lpszBuffer) const;
	int   GetTextLen (int nIndex) const;
	int   SelectString (int nStartAfter, LPCTSTR lpszItem);
	void  ResetContent();
	void  FontsChanged();
	int   SetItemData (int nIndex, DWORD dwItemData);
	DWORD GetItemData (int nIndex) const;
	int   SetItemDataPtr (int nIndex, void* pData);
	void* GetItemDataPtr (int nIndex) const;
	int   SetItemDataObjPtr (int nIndex, CListBoxODData* pListBoxODData);
	CListBoxODData* GetItemDataObjPtr (int nIndex) const;

protected:
	int GetHeight (bool bRecalc = false);

private:
	bool CheckListBoxData (CListBoxODData** ppListBoxODData, LPCTSTR lpszItem);

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSortListBoxOD)
	//}}AFX_MSG
	afx_msg LRESULT OnSetTabStops (WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
