// SortListCtrl.h : header file
// Copyright (c) 2016 by David Wincelberg
/////////////////////////////////////////////////////////////////////////////

#pragma once

class CListCtrlData;
class CListCtrlOrder;
class CStringOrder;

/////////////////////////////////////////////////////////////////////////////
// CSortListCtrl window

class CSortListCtrl : public CListCtrl
{
// Construction/Destruction
public:
	CSortListCtrl (CListCtrlOrder* pListCtrlOrder = nullptr, bool bHandleDelete = true);
	CSortListCtrl (CStringOrder* pStringOrder, bool bHandleDeleteInner = true,
		bool bHandleDeleteOuter = true);
	virtual ~CSortListCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSortListCtrl)
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Attributes
private:
	CListCtrlOrder* m_pListCtrlOrder;
	bool m_bHandleDelete;
	bool m_bAllowOrderMod;
	int  m_nLastCol;
	bool m_bSorting;
	bool m_bReverse;
	bool m_bResetDir;
	bool m_bSuspend;

// Operations
public:
	void  SetSortOrder (CListCtrlOrder* pListCtrlOrder, bool bHandleDelete = true);
	void  SetStringOrder (CStringOrder* pStringOrder, bool bHandleDelete = true);
	void  Sort (int nCol = 0, bool bReverse = false);
	void  SetColSorted (int nCol = 0, bool bReverse = false);
	void  SuspendColSort (bool bSuspend) {m_bSuspend = bSuspend;};
	int   InsertItem (int nItem, LPCTSTR lpszItem, CListCtrlData* pListCtrlData = nullptr);
	int   InsertItem (int nItem, LPCTSTR lpszItem, int nImage,
		  CListCtrlData* pListCtrlData = nullptr);
	int   InsertItem (UINT nMask, int nItem, LPCTSTR lpszItem, UINT nState, UINT nStateMask,
		  int nImage, LPARAM lParam, CListCtrlData* pListCtrlData = nullptr);
	int   InsertItem (LVITEM* pItem, CListCtrlData* pListCtrlData = nullptr);
	BOOL  DeleteItem (int nItem);
	BOOL  SetItemData (int nItem, DWORD dwData);
	DWORD GetItemData (int nItem) const;
	BOOL  SetItemDataObjPtr (int nItem, CListCtrlData* pListCtrlData);
	CListCtrlData* GetItemDataObjPtr (int nItem) const;

private:
	bool CheckListCtrlData (CListCtrlData** ppListCtrlData, LPCTSTR lpszItem,
		 LPARAM lParam = 0);
	void Resort();
	bool GetReverse (int nColumn, bool bUpdate = true);
	static int CALLBACK CompareFunc (LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSortListCtrl)
	afx_msg void OnGetDispInfo(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnColumnClick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeleteAllIems(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeleteItem(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
